$XGENIOCTRL_SDA = $XGENIOCTRL_SCL = $XGENIODATA_SDA = $XGENIODATA_SCL = 0;

sub one_or_zero {
    return "1" if not $_[0];
    # Sanity check
    not $_[1] or die "Got $_ at $. at ", __LINE__, "\n";
    return "0";
}

while (<>) {
    chomp;
    if (not /^write 3c00/) { 
	print $_, "\n";
	next;
    }
    /([0-9a-f]{2})\s*$/ or die "Got $_ at $. at ", __LINE__, "\n";
    $write_register = hex($1);
    if ($write_register != 0x2A && $write_register != 0x2B) {
	print $_, "\n";
	next;
    }
    $save = $_;
    $_ = <>;
    chomp;
    if (not /^read 3c0a/) {
	print $save, "\n";
	next;
    }
    /([0-9a-f]{2})\s*$/ or die "Got $_ at $. at ", __LINE__, "\n";
    $read_value = hex($1);
    $_ = <>;
    chomp;
    if (/^write 3c0a/) {
	/([0-9a-f]{2})\s*$/ or die "Got $_ at $. at ", __LINE__, "\n";
	$write_value = hex($1);
	if ($write_register == 0x2A) {
	    $XGENIOCTRL_SDA = $write_value & 0x10;
	    $XGENIOCTRL_SCL = $write_value & 0x20;
	    $NEW_SDA = one_or_zero($XGENIOCTRL_SDA, $XGENIODATA_SDA);
	    $NEW_SCL = one_or_zero($XGENIOCTRL_SCL, $XGENIODATA_SCL);
	    print "SET $NEW_SCL $NEW_SDA\n" if $NEW_SDA != $CUR_SDA || $NEW_SCL != $CUR_SCL;
	    $CUR_SDA = $NEW_SDA;
	    $CUR_SCL = $NEW_SCL;
	}
	elsif ($write_register == 0x2B) {
	    $XGENIODATA_SDA = $write_value & 0x10;
	    $XGENIODATA_SCL = $write_value & 0x20;
	    $NEW_SDA = one_or_zero($XGENIOCTRL_SDA, $XGENIODATA_SDA);
	    $NEW_SCL = one_or_zero($XGENIOCTRL_SCL, $XGENIODATA_SCL);
	    print "SET $NEW_SCL $NEW_SDA\n" if $NEW_SDA != $CUR_SDA || $NEW_SCL != $CUR_SCL;
	    $CUR_SDA = $NEW_SDA;
	    $CUR_SCL = $NEW_SCL;
	}
	else {
	    die "Got $_ at $. at ", __LINE__, "\n";
	}
    }
    else {
	# Sanity checks
	if ($write_register == 0x2B) {
	    print "GET ", ($read_value & 0x10) ? "1" : "0", "\n" if $CUR_SDA == "1" && $CUR_SCL == "1";
	}
	else {
	    die "Got $_ at $. at ", __LINE__, "\n";
	}
	redo;
    }
}







