while (<>) {
    chomp;
    if (not /.*([0-9a-f]{2})\s*$/) {
	print $_, "\n";
	next;
    }
    $val = hex($1);
    if (/^write 3c00/) {
	if ($val == 0x06) {
	    print "XCURCTRL\n";
	}
	elsif ($val == 0x1e) {
	    print "XMISCCTRL\n";
	}
	elsif ($val == 0x1a) {
	    print "XPIXCLKCTRL\n";
	}
	elsif ($val == 0x38) {
	    print "XZOOMCTRL\n";
	}
	else {
	    print $_ , "\n";
	}
    }
    elsif (/^read 1fcc/) {
	printf "READ MISC %02x\n", $val;
    }
    elsif (/^write 1fc2/) {
	printf "WRITE MISC %02x\n", $val;
    }
    elsif (/^write 1fd4/) {
	printf "CRTC index %02x\n", $val;
    }
    elsif (/^write 1fd5/) {
	printf "Write CRTC %02x\n", $val;
    }
    elsif (/^read 1fd5/) {
	printf "Read CRTC %02x\n", $val;
    }
    elsif (/^write 1fde/) {
	printf "CRTCEXT index %02x\n", $val;
    }
    elsif (/^read 1fdf/) {
	printf "Write CRTCEXT %02x\n", $val;
    }
    elsif (/^write 1fdf/) {
	printf "Read CRTCEXT %02x\n", $val;
    }
    elsif (/^write 1fc4/) {
	printf "SEQ index %02x\n", $val;
    }
    elsif (/^write 1fc5/) {
	printf "Write SEQ %02x\n", $val;
    }
    elsif (/^read 1fc5/) {
	printf "Read SEQ %02x\n", $val;
    }
    elsif (/^write 1fce/) {
	printf "GCTL index %02x\n", $val;
    }
    elsif (/^write 1fcf/) {
	printf "Write GCTL %02x\n", $val;
    }
    else {
	print $_, "\n";
    }
}
